#ifndef _BATTLEMAIN_H_
#define _BATTLEMAIN_H_

//by Chad Serrant
#include <stdio.h>
#include <math.h>
#include "allegro.h"
#include "dataObj.h"
#include "unitList.h"
#include <vector>
using namespace std;

//temp
#include "unitGraphics.h"
#include "hitbox.h"

class battleMain {

public:

  battleMain ();

  //initialization
  int init ();
  void restart (bool, int);
  void go ();

  //accessors
  BITMAP * getBuffer ();

  //modifiers
  void setDataObj (dataObj *);

  //rendering
  void draw (BITMAP *, BITMAP *);
  void drawBackground (BITMAP *, BITMAP *);
  void drawUnits (BITMAP *);
  void drawCursor (BITMAP *);
  void drawDisplay (BITMAP *);
  void drawHPBar (BITMAP *, float);
  void drawTimerBar (BITMAP *, float);
  void drawStatus (BITMAP *, unit *);

  //model processing
  void applyInput ();

  //unit data

  ~battleMain ();

  //fields
  unitList * units;

  BITMAP * buffer;
  BITMAP * gameOutput;
  BITMAP * youWin;
  BITMAP * youLose;
  BITMAP * introPic;

  BITMAP * clockPic;
  BITMAP * heartPic;

  BITMAP * invicPic;
  BITMAP * stunnedPic;
  BITMAP * speedUpPic;
  BITMAP * kbDownPic;
  BITMAP * nojuicePic;
  BITMAP * dmgDownPic;

  int arenaX, arenaY;
  dataObj *dO;
  int battleMode;
  int displayTimer;
  int stageTime;

  //temporary
  unitGraphics * uG;
  hitbox * hb;
};
#endif
